package datahub;

import java.util.ArrayList;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import datahub.model.Dataset;

@Repository
public interface DatasetRepository extends CrudRepository<Dataset, Integer>,DatasetRepositoryCustom {

	@Query(value = "select d.* from dataset d, user u where d.user_id =u.id and d.name = ?1 and u.email = ?2", nativeQuery = true)
	public ArrayList<Dataset> getDatasetUserEmailAndName(String name, String email);
	
	@Query(value = "select d.* from dataset d, user u where d.user_id =u.id and u.email = ?1", nativeQuery = true)
	public ArrayList<Dataset> getDatasetUserEmail(String email);
	
}
