package datahub.firebase;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import javax.annotation.PostConstruct;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import com.google.api.client.util.Value;
import com.google.auth.oauth2.GoogleCredentials;
import com.google.firebase.FirebaseApp;
import com.google.firebase.FirebaseOptions;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;

@Configuration
public class FirebaseConfig {
	
	@Bean
    public DatabaseReference firebaseDatabse() {
        DatabaseReference firebase = FirebaseDatabase.getInstance().getReference();
        return firebase;
    }
 
//    @Value("${rs.pscode.firebase.database.url}")
//    private String databaseUrl;
// 
//    @Value("${rs.pscode.firebase.config.path}")
//    private String configPath;
// 
    @PostConstruct
    public void init() {
 
        /**
         * https://firebase.google.com/docs/server/setup
         * 
         * Create service account , download json
         */
    	FileInputStream serviceAccount;
		try {
			serviceAccount = new FileInputStream("files/Firebase/datahubwake-firebase-adminsdk-2kqch-952b81215c.json");
			
			FirebaseOptions options = new FirebaseOptions.Builder()
			  .setCredentials(GoogleCredentials.fromStream(serviceAccount))
			  .setDatabaseUrl("https://datahubwake.firebaseio.com")
			  .build();

			FirebaseApp.initializeApp(options);
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

    			
 
    }
	
}
