package datahub.firebase;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ExecutionException;

import com.google.api.core.ApiFuture;

import com.google.auth.oauth2.GoogleCredentials;
import com.google.cloud.firestore.CollectionReference;
import com.google.cloud.firestore.DocumentReference;
import com.google.cloud.firestore.DocumentSnapshot;
import com.google.cloud.firestore.Firestore;
import com.google.cloud.firestore.FirestoreOptions;
import com.google.cloud.firestore.Query;
import com.google.cloud.firestore.QueryDocumentSnapshot;
import com.google.cloud.firestore.QuerySnapshot;
import com.google.cloud.firestore.WriteResult;
import com.google.firebase.FirebaseApp;
import com.google.firebase.FirebaseOptions;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseAuthException;
import com.google.firebase.auth.UserRecord;
import com.google.firebase.auth.UserRecord.CreateRequest;
import com.google.firebase.cloud.FirestoreClient;

import datahub.model.Dataset;
import datahub.model.User;
import datahub.tools.DataGatherer;

public class FirebaseDataHandler {
	
	private static String UPLOADED_FOLDER = "files/users/";
	

	public static boolean createUser(String email,
			String password) {
		
		CreateRequest request = new CreateRequest()
			    .setEmail(email)
			    .setPassword(password);

			UserRecord userRecord;
			try {
				userRecord = FirebaseAuth.getInstance().createUser(request);
				System.out.println("Successfully created new user: " + userRecord.getUid());
			
					return true;  
				
			} catch (FirebaseAuthException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		return false;
	}
	
	public static boolean deleteUser(String email) {
		
		try {
			UserRecord userRecord = FirebaseAuth.getInstance().getUserByEmail(email);
			FirebaseAuth.getInstance().deleteUser(userRecord.getUid());
			System.out.println("Successfully deleted user.");
			
		} catch (FirebaseAuthException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return true;
	}
	
}
