package datahub.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import com.fasterxml.jackson.annotation.JsonBackReference;



@Entity
public class Label {

	 @Id
	 @GeneratedValue(strategy = GenerationType.IDENTITY)
	 private int id;
	
	// Variables
	@Column(name = "name")
	private String name;
	@Column(name = "data_type")
	private String dataType;
	@Column(name = "concept")
	private String concept;
	@ElementCollection(targetClass=String.class)
	private List<String> keywords;
	
	@ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "dataset_file_id", referencedColumnName = "id")
	@JsonBackReference
    private DatasetFile datasetFile;
	
	// Constructors
	public Label() {
		super();
		this.name = "";
		this.dataType = "";
		this.concept = "";
		this.keywords = new ArrayList<String>();
	}
	
	public Label(String name, String dataType, String concept) {
		super();
		this.name = name;
		this.dataType = dataType;
		this.concept = concept;
		this.keywords = new ArrayList<String>();
	}
	
	
	// Setters and Getters
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDataType() {
		return dataType;
	}

	public void setDataType(String dataType) {
		this.dataType = dataType;
	}

	public String getConcept() {
		return concept;
	}

	public void setConcept(String concept) {
		this.concept = concept;
	}
	
	public DatasetFile getDatasetFile() {
		return datasetFile;
	}

	public void setDatasetFile(DatasetFile datasetFile) {
		this.datasetFile = datasetFile;
	}
	

	public List<String> getKeywords() {
		return keywords;
	}

	public void setKeywords(List<String> keywords) {
		this.keywords = keywords;
	}
	
	// Methods
	
	
	



	// Override Methods
	@Override
	public String toString() {
		return "Label [name=" + name + ", dataType=" + dataType + "]";
	}
	
}
