package datahub.model;

import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonManagedReference;

@Entity(name = "User")
@Table(name = "user")
public class User {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;
	
	@Column(name = "email")
	private String email;
	@Column(name = "name")
	private String name;
	@Column(name = "institution")
	private String institution;
	@Column(name = "department")
	private String department;
	@Column(name = "role")
	private String role;
	
	@OneToMany(
        mappedBy = "user",
        cascade = CascadeType.ALL,
        orphanRemoval = true,
        fetch = FetchType.LAZY
    )
	@JsonManagedReference
	private Set<Dataset> datasets;
	
	
	//Constructors
	public User() {
		this.email = "";
		this.name = "";
		this.institution = "";
		this.department = "";
		this.role = "";
	}
	
	public User(String email, String name, String institution, String department, String role) {
		this.email = email;
		this.name = name;
		this.institution = institution;
		this.department = department;
		this.role = role;
	}

	
	
	//Getters and Setters
	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getInstitution() {
		return institution;
	}

	public void setInstitution(String institution) {
		this.institution = institution;
	}

	public String getDepartment() {
		return department;
	}

	public void setDepartment(String department) {
		this.department = department;
	}

	public String getRole() {
		return role;
	}

	public void setRole(String role) {
		this.role = role;
	}
	
	public int getId() {
		return id;
	}

	public Set<Dataset> getDatasets() {
		return datasets;
	}

	public void setDatasets(Set<Dataset> datasets) {
		this.datasets = datasets;
	}

	@Override
	public String toString() {
		return "User [email=" + email + ", name=" + name + ", institution=" + institution + ", department=" + department
				+ ", role=" + role + "]";
	}
	
}
