package test;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import org.springframework.boot.SpringApplication;

import com.wake.datahubbackend.datahubbackend.DatahubBackendApplication;

import datahub.DatasetRepository;
import datahub.model.Dataset;
import datahub.model.User;
import datahub.tools.DataGatherer;

public class TestData {
	
	private static String UPLOADED_FOLDER = "files/users/";

	public static void generateRandomeData(String user, int n,DatasetRepository datasetRepository,User u) {
		String[] rnames = {"tiempo","arte","meteo","politica","muertes","coronavirus","gatos","clase","instituto","universidad","sanidad","probeta","cielo","lluvia","sol","nubes"};
		String[] rcategories = {"Transport","Education","Economy","Art","Politics","Health","Science"};
		String description = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed quis euismod lectus. Integer faucibus risus nisl, sit amet pellentesque urna consequat nec. Suspendisse vel sagittis nibh. Proin bibendum lorem lorem, nec rutrum eros tristique quis. Mauris sed mauris sed lacus bibendum lobortis nec sed dolor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur elementum sit amet magna sed imperdiet. Mauris id vulputate eros, et placerat ex. Sed pulvinar tempus velit non condimentum. Praesent sit amet arcu velit.";
		
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter("files/datasetsRandom_"+user));
			
			for(int i = 0; i < n ; i++) {
				int key1 = (int) Math.floor(Math.random()*rnames.length);
				int key2 = (int) Math.floor(Math.random()*rnames.length);
				int key3 = (int) Math.floor(Math.random()*rnames.length);
				
				ArrayList<String> keywords = new ArrayList<>();
				keywords.add(rnames[key1]);
				keywords.add(rnames[key2]);
				keywords.add(rnames[key3]);
				
				ArrayList<String> formats = new ArrayList<>();
				
				int category = (int) Math.floor(Math.random()*rcategories.length);
				
				Dataset d = new Dataset();
				d.setUser(u);
				datasetRepository.save(d);
				
				d.setCategory(rcategories[category]);
				d.setKeywords(keywords);
				
				if(i%2 == 0) {
					formats.add("CSV");
				}
				else {
					formats.add("JSON");
				}
				
				d.setName("Dataset dummy "+i);
				d.setOwnerEmail(user);
				d.setOwner(user);
				d.setDescription(description);
				d.populateTermsAndFormat();
				d.setFormats(formats);
				String documentName = d.getOwnerEmail()+"_"+d.getName();
				writer.append(documentName);
				writer.append("\n");
				
				datasetRepository.save(d);
			}
			
			writer.close();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//guardar en un fichero el nombre de los documentos random generados para poder borrarlos con facilidad
		
		
		
		
	}
	
	
	public static void testGetSampleData(String user, String dataset, String distribution) {
		
		String filePath = UPLOADED_FOLDER + user + "/"+ dataset+"/"+distribution;
		  
		File file = new File(filePath);
		
		ArrayList<ArrayList<String>> sampleData = new ArrayList<ArrayList<String>>();
		
		sampleData = DataGatherer.getSampleData(file, 100);
		
		System.out.println("ROWS -- >"+sampleData.size()+ "     "+sampleData);
		
	}
	
	public static void getJSONData(String user, String dataset, String distribution) {
		String filePath = UPLOADED_FOLDER + user + "/"+ dataset+"/"+distribution;
		  
		File file = new File(filePath);
		
		//DataGatherer.getJSONContent(file);
		
		String s = DataGatherer.getJSONRows(file, 1);
		
		System.out.println(s);
	}
	
	public static void main(String[] args) {
		
//		testGetSampleData("a@a.com", "Dataset de prueba", "Callejero-2020.csv");
//		testGetSampleData("a@a.com", "Dataset de prueba", "data.csv");
		
		getJSONData("a@a.com", "Dataset de prueba", "weather.json");
	}
	
}
